#include <stdlib.h>
#include "Entities.hpp"
#include "x++.hpp"


////////////////////////////////////////////////////////////////////////////////

sEntity::sEntity()
: m_EntityType(NONE)
, m_X(0)
, m_Y(0)
, m_Layer(0)
{
}

////////////////////////////////////////////////////////////////////////////////

sEntity::EntityType
sEntity::GetEntityType() const
{
  return m_EntityType;
}

////////////////////////////////////////////////////////////////////////////////

sWarpEntity::sWarpEntity()
: m_DestinationX(0)
, m_DestinationY(0)
, m_DestinationLayer(0)
, m_Fade(0)
{
  m_EntityType = WARP;
}

////////////////////////////////////////////////////////////////////////////////

sPersonEntity::sPersonEntity()
: m_MovementType(RANDOM)
, m_StartDirection(UP)
, m_WalkSpeed(0)
, m_WalkDuration(0)
, m_WalkDelay(0)
, m_DialogueType(TEXT)
{
  m_EntityType = PERSON;
}

////////////////////////////////////////////////////////////////////////////////

sTriggerEntity::sTriggerEntity()
{
  m_EntityType = TRIGGER;
}

////////////////////////////////////////////////////////////////////////////////

sDoodadEntity::sDoodadEntity()
: m_Obstructive(false)
, m_ActivationMethod(NONE)
{
  m_EntityType = DOODAD;
}

////////////////////////////////////////////////////////////////////////////////
