#ifndef SS_INTERNAL_HPP
#define SS_INTERNAL_HPP


#include "SS_Types.hpp"


struct sToken
{
  sToken()
  : t("")
  , location(0)
  {
  }

  sToken(sString _t, int _location, int _line)
  : t(_t)
  , location(_location)
  , line(_line)
  {
  }

  sString t;
  int     location;
  int     line;
};


struct sScriptException
{
  sScriptException(sString _message)
  : message(_message) {}
  sScriptException(sString _message, sToken _token) 
  : message(_message), token(_token) {}

  sString message;
  sToken  token;
};


#endif
